﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;

namespace ForLoopSpeedTest
{
    class Program
    {
        static void Main(string[] args)
        {
            const int Iterations = 1024 * 32;
            const int TestArrSize = 1024 * 16;
            int[] TestArr = new int[TestArrSize];
            Random RandomObj = new Random();
            for (int i = 0; i < TestArrSize; i++)
                TestArr[i] = RandomObj.Next();
            IEnumerable<int> TestArrIEnumerable = TestArr;

            Console.WriteLine("Iterations: " + Iterations.ToString());
            Console.WriteLine("TestArrSize: " + TestArrSize.ToString());

            Stopwatch Timer0 = new Stopwatch();
            Timer0.Start();
            int UselessTemp0 = 0;
            for (int Iteration = 0; Iteration < Iterations; Iteration++)
                for (int i = 0; i < TestArrSize; i++)
                    UselessTemp0 = TestArr[i];
            Timer0.Stop();

            Stopwatch Timer1 = new Stopwatch();
            Timer1.Start();
            int UselessTemp1 = 0;
            for (int Iteration = 0; Iteration < Iterations; Iteration++)
                foreach (int Temp in TestArrIEnumerable)
                    UselessTemp1 = Temp;
            Timer1.Stop();

            Console.WriteLine("Time0: " + Timer0.Elapsed.TotalMilliseconds.ToString() + "ms (for)", UselessTemp0);
            Console.WriteLine("Time1: " + Timer1.Elapsed.TotalMilliseconds.ToString() + "ms (foreach)", UselessTemp1); //Letzer Parameter damit nichts wegoptimiert wird...
            Console.ReadLine();
        }

    }
}
